//flare.cs

//audio
datablock AudioProfile(flareShotSound)
{
   filename    = "./flare_fire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(flareBurnSound)
{
   filename    = "./flare_hit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(flareSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 900;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.5 0.5 0.5 0.8";
	colors[1]     = "0.5 0.5 0.5 0.5";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 0.25;
   sizes[1]      = 2.0;
	sizes[2]      = 1.65;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flareSmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flareSmokeParticle";

   uiName = "Flare Smoke";
};

datablock ParticleData(flareTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 325;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.5 0.2 1";
	colors[1]     = "1 0.4 0.2 1";
	colors[2]     = "1 0.3 0.2 0.0";
	sizes[0]      = 0.50;
	sizes[1]      = 0.35;
	sizes[2]      = 0.35;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flareTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flareTrailParticle";
};

datablock ParticleData(flareExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.4 0.2 0.9";
	colors[1]     = "0.9 0.5 0.2 0.0";
	sizes[0]      = 0.55;
	sizes[1]      = 1.25;

	useInvAlpha = true;
};
datablock ParticleEmitterData(flareExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 9;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 179;
   thetaMax         = 180;
   phiReferenceVel  = 179;
   phiVariance      = 180;
   overrideAdvance = false;
   particles = "flareExplosionParticle";
};

datablock ParticleData(flareExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.5 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.9;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flareExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flareExplosionRingParticle";
};

datablock ExplosionData(flareExplosion)
{
   //explosionShape = "";
	soundProfile = flareBurnSound;

   lifeTimeMS = 150;

   particleEmitter = flareExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = flareExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 8;
   lightEndRadius = 8;
   lightStartColor = "1 0.6 0";
   lightEndColor = "1 0.6 0";
};

AddDamageType("Flare",   '<bitmap:base/client/ui/generic> %1',    '%2 <bitmap:base/client/ui/generic> %1',0.2,1);
datablock ProjectileData(flareProjectile)
{
   directDamage        = 35;
   directDamageType    = $DamageType::Flare;
   radiusDamageType    = $DamageType::Flare;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = flareExplosion;
   particleEmitter     = flareTrailEmitter;

   muzzleVelocity      = 60;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 40000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 0.6 0";

   uiName = "Flare";
};

//////////
// item //
//////////
datablock ItemData(flareItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./flaregun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Flare Gun";
	iconName = "./ci_flaregun";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = flareImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(flareImage)
{
   // Basic Item properties
   shapeFile = "./flaregun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = flareProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = flareItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Reload";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Reload";
	stateAllowImageChange[1]         = true;
	stateSequence[1]                = "Reload";
	stateScript[1]                  = "Reload";
	stateSequence[1]	= "Reload";
	stateTransitionOnTimeout[1]     = "Ready";
	stateWaitForTimeout[1]			= true;
	stateEmitter[1]					= flareSmokeEmitter;
	stateEmitterTime[1]				= 0.05;
	stateEmitterNode[1]				= mount1;
	stateTimeoutValue[1]				= 1.85;

	stateName[2] = "Ready";
	stateTransitionOnTriggerDown[2]  = "Fire";
	stateAllowImageChange[2]         = true;
	stateSequence[2]	= "Ready";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Pause1";
	stateTimeoutValue[3]            = 0.14;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= flareShotSound;

	stateName[4]			= "Pause1";
	stateSequence[4]                = "Pause1";
	stateTransitionOnTimeout[4]     = "Ammo2";
	stateWaitForTimeout[4]			= true;
	stateTimeoutValue[4]				= 0.15;
	stateSequence[4]	= "Ready";

	stateName[5] = "Ammo2";
	stateTransitionOnTriggerDown[5]  = "Fire2";
	stateAllowImageChange[5]         = true;
	stateSequence[5]	= "Ready";

	stateName[6]                    = "Fire2";
	stateTransitionOnTimeout[6]     = "Reload";
	stateTimeoutValue[6]            = 0.14;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]			= true;
	stateEmitterTime[6]				= 0.05;
	stateEmitterNode[6]				= "muzzleNode";
	stateSound[6]					= flareShotSound;
};

function flareImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}
